#!/bin/bash

set -e

MARIAN=../build
MARIAN_MASTER=../build_master

SRC=en
TRG=de

mkdir -p speed_fbgemm

for i in 16 17 18 19 20 21 22; do
	sacrebleu -t wmt$i -l $SRC-$TRG --echo src > speed_fbgemm/wmt$i.$SRC
	cat speed_fbgemm/wmt*.$SRC > speed_fbgemm/big.$SRC

	sacrebleu -t wmt$i -l $SRC-$TRG --echo ref > speed_fbgemm/wmt$i.$TRG
	cat speed_fbgemm/wmt*.$TRG > speed_fbgemm/big.ref.$TRG

done
echo "testset size: " `wc -l speed_fbgemm/big.ref.$TRG`
echo "WITH shortlist"
echo "beam1opt shortlist"
taskset -c 0	$MARIAN/marian-decoder $@ \
	    --relative-paths -m model.npz.best-bleu-detok.npz -v vocab.spm vocab.spm \
	    -i speed_fbgemm/big.$SRC -o speed_fbgemm/big.$TRG \
	    --beam-size 1 --mini-batch 32 --maxi-batch 100 --maxi-batch-sort src -w 128 \
	    --skip-cost --shortlist lex.bin --cpu-threads 1 \
	    --quiet --quiet-translation --log speed_fbgemm/cpu.big.log

tail -n1 speed_fbgemm/cpu.big.log
sacrebleu speed_fbgemm/big.ref.$TRG < speed_fbgemm/big.$TRG | tee speed_fbgemm/cpu.big.$TRG.bleu

echo "master shortlist"
taskset -c 0    $MARIAN_MASTER/marian-decoder $@ \
            --relative-paths -m model.npz.best-bleu-detok.npz -v vocab.spm vocab.spm \
            -i speed_fbgemm/big.$SRC -o speed_fbgemm/big.$TRG \
            --beam-size 1 --mini-batch 32 --maxi-batch 100 --maxi-batch-sort src -w 128 \
            --skip-cost --shortlist lex.bin --cpu-threads 1 \
            --quiet --quiet-translation --log speed_fbgemm/cpu.big.log

tail -n1 speed_fbgemm/cpu.big.log
sacrebleu speed_fbgemm/big.ref.$TRG < speed_fbgemm/big.$TRG | tee speed_fbgemm/cpu.big.$TRG.bleu

echo "WITHOUT shortlist"

echo "beam1opt, no shortlist"
taskset -c 0    $MARIAN/marian-decoder $@ \
            --relative-paths -m model.npz.best-bleu-detok.npz -v vocab.spm vocab.spm \
            -i speed_fbgemm/big.$SRC -o speed_fbgemm/big.$TRG \
            --beam-size 1 --mini-batch 32 --maxi-batch 100 --maxi-batch-sort src -w 128 \
            --skip-cost --cpu-threads 1 \
            --quiet --quiet-translation --log speed_fbgemm/cpu.big.log

tail -n1 speed_fbgemm/cpu.big.log
sacrebleu speed_fbgemm/big.ref.$TRG < speed_fbgemm/big.$TRG | tee speed_fbgemm/cpu.big.$TRG.bleu

echo "master, no shortlist"
taskset -c 0    $MARIAN_MASTER/marian-decoder $@ \
            --relative-paths -m model.npz.best-bleu-detok.npz -v vocab.spm vocab.spm \
            -i speed_fbgemm/big.$SRC -o speed_fbgemm/big.$TRG \
            --beam-size 1 --mini-batch 32 --maxi-batch 100 --maxi-batch-sort src -w 128 \
            --skip-cost --cpu-threads 1 \
            --quiet --quiet-translation --log speed_fbgemm/cpu.big.log

tail -n1 speed_fbgemm/cpu.big.log
sacrebleu speed_fbgemm/big.ref.$TRG < speed_fbgemm/big.$TRG | tee speed_fbgemm/cpu.big.$TRG.bleu
